diff -Nuar ../vim72.orig/src/os_win32.c src/os_win32.c
--- ../vim72.orig/src/os_win32.c	2008-08-09 18:29:28.000000000 +0800
+++ src/os_win32.c	2009-05-08 14:05:30.796875000 +0800
@@ -3110,6 +3110,11 @@
     PROCESS_INFORMATION pi;
     DWORD		ret = 0;
     HWND		hwnd = GetFocus();
+# ifdef FEAT_MBYTE
+    char *newcmd = cmd;
+    vimconv_T conv;
+    char_u *enc = NULL;
+# endif
 
     si.cb = sizeof(si);
     si.lpReserved = NULL;
@@ -3135,9 +3140,27 @@
 		|| STRNICMP(cmd, "c:\\command.com", 14) == 0))
 	cmd += 3;
 
+#ifdef FEAT_MBYTE
+    conv.vc_type = CONV_NONE;
+    enc = enc_locale();
+    convert_setup(&conv, p_enc, enc);
+    vim_free(enc);
+    if (conv.vc_type != CONV_NONE)
+    {
+	conv.vc_fail = TRUE;
+	newcmd = string_convert(&conv, cmd, NULL);
+	if (newcmd == NULL)
+	{
+	    (void)EMSG(_("Can not convert string"));
+	    return 1;
+	}
+
+    }
+#endif
+
     /* Now, run the command */
     CreateProcess(NULL,			/* Executable name */
-		  cmd,			/* Command to execute */
+		  newcmd,		/* Command to execute */
 		  NULL,			/* Process security attributes */
 		  NULL,			/* Thread security attributes */
 		  FALSE,		/* Inherit handles */
@@ -3148,6 +3171,9 @@
 		  &si,			/* Startup information */
 		  &pi);			/* Process information */
 
+#ifdef FEAT_MBYTE
+    vim_free(newcmd);
+#endif
 
     /* Wait for the command to terminate before continuing */
     if (g_PlatformId != VER_PLATFORM_WIN32s)
@@ -3224,6 +3250,11 @@
 {
     int		x = 0;
     int		tmode = cur_tmode;
+# ifdef FEAT_MBYTE
+    vimconv_T conv;
+    char_u *enc = NULL;
+    char_u *p = NULL;
+# endif
 #ifdef FEAT_TITLE
     char szShellTitle[512];
 
@@ -3328,6 +3359,25 @@
 			newcmd[STRLEN(newcmd) - 1] = NUL;
 		}
 
+# ifdef FEAT_MBYTE
+		conv.vc_type = CONV_NONE;
+		enc = enc_locale();
+		convert_setup(&conv, p_enc, enc);
+		vim_free(enc);
+		if (conv.vc_type != CONV_NONE)
+		{
+		    conv.vc_fail = TRUE;
+		    p = string_convert(&conv, newcmd, NULL);
+		    vim_free(newcmd);
+		    if (p == NULL)
+		    {
+			EMSG(_("Cannot convert string"));
+			return 1;
+		    }
+		    newcmd = p;
+		}
+#endif
+
 		/*
 		 * Now, start the command as a process, so that it doesn't
 		 * inherit our handles which causes unpleasant dangling swap
